<template>
  <div class="article-list">
    <Row>
      <Col
        v-for="(articleItem, index) in articleList"
        :key="articleItem.id"
        :sm="24"
        :md="(index + 1) % 2 && articleItem.type === 'double' ? 24 : 12"
        :lg="articleItem.type === 'double' ? 16 : 8"
      >
      <Card
        :id="articleItem.id"
        :title="articleItem.title"
        :desc="articleItem.description"
        :image="getImage()"
      />
      </Col>
    </Row>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import Card from 'components/Card';
import Row from 'components/Row';
import Col from 'components/Col';

export default {
  name: 'Home',
  components: {
    [Row.name]: Row,
    [Col.name]: Col,
    [Card.name]: Card
  },
  computed: {
    ...mapState({
      articleList (state) {
        return state.articleList;
      }
    })
  },
  async beforeMount () {
    try {
      await this.getArticleList();
    } catch (err) {
      console.log(err);
      this.$router.push('/error/500');
    }
  },
  methods: {
    ...mapActions(['getArticleList']),
    getImage () {
      let side = Math.random() * (600 - 400) + 400;
      return `https://unsplash.it/300/${side}/?random`;
    }
  }
};
</script>

<style scoped>

  .article-list {
    background: #ecf0f1;
  }

</style>